CFPRIME INGV01                                                          INGV01      1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
      SUBROUTINE INGV01                                                 INGV01      3
CD                                                                      INGV01      4
CD    TO PERFORM INITIALIZATION AND DATA CHECK FOR GOVERNOR TYPES 1     INGV01      5
CD    AND 2.                                                            INGV01      6
CD                                                                      INGV01      7
CD    THE DATA STRUCTURE AFTER THE INITIALIZATION IS GIVEN BELOW.       INGV01      8
CD                                                                      INGV01      9
CD   9.1 Prime-mover turbine-governor type 1                            INGV01     10
CD                                                                      INGV01     11
CD     Governor data                                                    INGV01     12
CD                                                                      INGV01     13
CD     DDAT(JGG+ 1)   = K1                                              INGV01     14
CD     DDAT(JGG+ 2)   = K2                                              INGV01     15
CD     DDAT(JGG+ 3)   = V1                                              INGV01     16
CD     DDAT(JGG+ 4)   = V2                                              INGV01     17
CD     DDAT(JGG+ 5)   = V3                                              INGV01     18
CD     DDAT(JGG+ 6)   = T1                                              INGV01     19
CD     DDAT(JGG+ 7)   = T2                                              INGV01     20
CD     DDAT(JGG+ 8)   = KR                                              INGV01     21
CD     DDAT(JGG+ 9)   = TSR                                             INGV01     22
CD     DDAT(JGG+10)   = L1                                              INGV01     23
CD     DDAT(JGG+11)   = L2                                              INGV01     24
CD     DDAT(JGG+12)   = TF1                                             INGV01     25
CD     DDAT(JGG+13)   = TF2                                             INGV01     26
CD     DDAT(JGG+14)   = XFV                                             INGV01     27
CD     DDAT(JGG+15)   = TFCV2                                           INGV01     28
CD     DDAT(JGG+16)   = XFCV                                            INGV01     29
CD     DDAT(JGG+17)   = THP                                             INGV01     30
CD     DDAT(JGG+18)   = TRH                                             INGV01     31
CD     DDAT(JGG+19)   = TIP                                             INGV01     32
CD     DDAT(JGG+20)   = TLP                                             INGV01     33
CD     DDAT(JGG+21)   = KBR                                             INGV01     34
CD     DDAT(JGG+22)   = FHP                                             INGV01     35
CD     DDAT(JGG+23)   = FIP                                             INGV01     36
CD     DDAT(JGG+24)   = PMAX                                            INGV01     37
CD     DDAT(JGG+25)   = FBRPR                                           INGV01     38
CD     DDAT(JGG+26)   = KA                                              INGV01     39
CD     DDAT(JGG+27)   = PDROP                                           INGV01     40
CD     DDAT(JGG+28)   = RLMT                                            INGV01     41
CD     DDAT(JGG+29)   = TI1                                             INGV01     42
CD     DDAT(JGG+30)   = TI2                                             INGV01     43
CD     DDAT(JGG+31)   = TI3                                             INGV01     44
CD     DDAT(JGG+32)   = TI4                                             INGV01     45
CD     DDAT(JGG+33)   = TI5                                             INGV01     46
CD     DDAT(JGG+34)   = LI1                                             INGV01     47
CD     DDAT(JGG+35)   = LI2                                             INGV01     48
CD     DDAT(JGG+36)   = IVOB                                            INGV01     49
CD     DDAT(JGG+37)   = PI1                                             INGV01     50
CD     DDAT(JGG+38)   = AI1                                             INGV01     51
CD     DDAT(JGG+39)   = PI2                                             INGV01     52
CD     DDAT(JGG+40)   = AI2                                             INGV01     53
CD     DDAT(JGG+41)   = XI1                                             INGV01     54
CD     DDAT(JGG+42)   = YI1                                             INGV01     55
CD     DDAT(JGG+43)   = XI2                                             INGV01     56
CD     DDAT(JGG+44)   = YI2                                             INGV01     57
CD     DDAT(JGG+45)   = CIDB1                                           INGV01     58
CD     DDAT(JGG+46)   = CIDB2                                           INGV01     59
CD     DDAT(JGG+47)   = TC1                                             INGV01     60
CD     DDAT(JGG+48)   = TC2                                             INGV01     61
CD     DDAT(JGG+49)   = TC3                                             INGV01     62
CD     DDAT(JGG+50)   = TC4                                             INGV01     63
CD     DDAT(JGG+51)   = TC5                                             INGV01     64
CD     DDAT(JGG+52)   = LC1                                             INGV01     65
CD     DDAT(JGG+53)   = LC2                                             INGV01     66
CD     DDAT(JGG+54)   = (reserved for future use)                       INGV01     67
CD     DDAT(JGG+55)   = PC1                                             INGV01     68
CD     DDAT(JGG+56)   = AC1                                             INGV01     69
CD     DDAT(JGG+57)   = PC2                                             INGV01     70
CD     DDAT(JGG+58)   = AC2                                             INGV01     71
CD     DDAT(JGG+59)   = XC1                                             INGV01     72
CD     DDAT(JGG+60)   = YC1                                             INGV01     73
CD     DDAT(JGG+61)   = XC2                                             INGV01     74
CD     DDAT(JGG+62)   = YC2                                             INGV01     75
CD     DDAT(JGG+63)   = CDB1                                            INGV01     76
CD     DDAT(JGG+64)   = CDB2                                            INGV01     77
CD     IDDAT(JGG+65)  = ILN                                             INGV01     78
CD     IDDAT(JGG+66)  = IFV                                             INGV01     79
CD                                                                      INGV01     80
CD     Governor states                                                  INGV01     81
CD                                                                      INGV01     82
CD     XSTATE(JPS+1)  = THP block                   : compulsory        INGV01     83
CD     XSTATE(JPS+2)  = TRH block                   : compulsory        INGV01     84
CD     XSTATE(JPS+3)  = TIP block                   : compulsory        INGV01     85
CD     XSTATE(JPS+4)  = TLP block                   : compulsory        INGV01     86
CD     XSTATE(JPS+5)  = TC3 block                   : compulsory        INGV01     87
CD     XSTATE(JPS+6)  = TC1 block                   : compulsory        INGV01     88
CD     XSTATE(JPS+7)  = TC5 block                   : compulsory        INGV01     89
CD     XSTATE(JPS+8)  = TI3 block                   : compulsory        INGV01     90
CD     XSTATE(JPS+9)  = TI1 block                   : compulsory        INGV01     91
CD     XSTATE(JPS+10) = TI5 block                   : compulsory        INGV01     92
CD     XSTATE(JPS+11) = TSR block                   : compulsory        INGV01     93
CD                                                                      INGV01     94
CD     Governor Y-variables                                             INGV01     95
CD                                                                      INGV01     96
CD     XLDREF(JYP+1)  = load reference signal                           INGV01     97
CD     CVP(JYP+2)     = control valve position                          INGV01     98
CD     BLRPR(JYP+3)   = boiler/reactor pressure                         INGV01     99
CD     PVP(JYP+4)     = pilot valve position                            INGV01    100
CD     AIV(JYP+5)     = updated value of multiplier A                   INGV01    101
CD     FAIV(JYP+6)    = intercept valve flow area                       INGV01    102
CD     FACV(JYP+7)    = control valve flow area                         INGV01    103
CD     INTL(JYP+8)    = integer for acceleration sensitive control      INGV01    104
CD                      = 0    the control is not triggered             INGV01    105
CD                      = 1    the control is triggered for the time    INGV01    106
CD                             less than T1 seconds; no signal has been INGV01    107
CD                             applied yet                              INGV01    108
CD                      = 2    the control is triggered and the signal  INGV01    109
CD                             is applied                               INGV01    110
CD     TSNTL(JYP+9)   = acceleration sensitive control trigger time     INGV01    111
CD     AKIV(JYP+10)   = steady-state value of multiplier A              INGV01    112
CD     PDEM(JYP+11)   = power demand from AGC control                   INGV01    113
CD     PSET(JYP+12)   = set point for boiler pressure control           INGV01    114
CD                                                                      INGV01    115
CD   9.2 Prime-mover Turbine-governor type 2                            INGV01    116
CD                                                                      INGV01    117
CD     Governor data                                                    INGV01    118
CD                                                                      INGV01    119
CD     DDAT(JGG+ 1)   = K1                                              INGV01    120
CD     DDAT(JGG+ 2)   = K2                                              INGV01    121
CD     DDAT(JGG+ 3)   = V1                                              INGV01    122
CD     DDAT(JGG+ 4)   = V2                                              INGV01    123
CD     DDAT(JGG+ 5)   = V3                                              INGV01    124
CD     DDAT(JGG+ 6)   = T1                                              INGV01    125
CD     DDAT(JGG+ 7)   = T2                                              INGV01    126
CD     DDAT(JGG+ 8)   = KR                                              INGV01    127
CD     DDAT(JGG+ 9)   = TSR                                             INGV01    128
CD     DDAT(JGG+10)   = L1                                              INGV01    129
CD     DDAT(JGG+11)   = L2                                              INGV01    130
CD     DDAT(JGG+12)   = TF1                                             INGV01    131
CD     DDAT(JGG+13)   = TF2                                             INGV01    132
CD     DDAT(JGG+14)   = XFV                                             INGV01    133
CD     DDAT(JGG+15)   = TFCV2                                           INGV01    134
CD     DDAT(JGG+16)   = XFCV                                            INGV01    135
CD     DDAT(JGG+17)   = THP                                             INGV01    136
CD     DDAT(JGG+18)   = TRH                                             INGV01    137
CD     DDAT(JGG+19)   = TIP                                             INGV01    138
CD     DDAT(JGG+20)   = TLP                                             INGV01    139
CD     DDAT(JGG+21)   = KBR                                             INGV01    140
CD     DDAT(JGG+22)   = FHP                                             INGV01    141
CD     DDAT(JGG+23)   = FIP                                             INGV01    142
CD     DDAT(JGG+24)   = PMAX                                            INGV01    143
CD     DDAT(JGG+25)   = FBRPR                                           INGV01    144
CD     DDAT(JGG+26)   = KA                                              INGV01    145
CD     DDAT(JGG+27)   = PDROP                                           INGV01    146
CD     DDAT(JGG+28)   = RLMT                                            INGV01    147
CD     DDAT(JGG+29)   = TI1                                             INGV01    148
CD     DDAT(JGG+30)   = TI2                                             INGV01    149
CD     DDAT(JGG+31)   = TI3                                             INGV01    150
CD     DDAT(JGG+32)   = TI4                                             INGV01    151
CD     DDAT(JGG+33)   = TI5                                             INGV01    152
CD     DDAT(JGG+34)   = LI1                                             INGV01    153
CD     DDAT(JGG+35)   = LI2                                             INGV01    154
CD     DDAT(JGG+36)   = IVOB                                            INGV01    155
CD     DDAT(JGG+37)   = PI1                                             INGV01    156
CD     DDAT(JGG+38)   = AI1                                             INGV01    157
CD     DDAT(JGG+39)   = PI2                                             INGV01    158
CD     DDAT(JGG+40)   = AI2                                             INGV01    159
CD     DDAT(JGG+41)   = XI1                                             INGV01    160
CD     DDAT(JGG+42)   = YI1                                             INGV01    161
CD     DDAT(JGG+43)   = XI2                                             INGV01    162
CD     DDAT(JGG+44)   = YI2                                             INGV01    163
CD     DDAT(JGG+45)   = CIDB1                                           INGV01    164
CD     DDAT(JGG+46)   = CIDB2                                           INGV01    165
CD     DDAT(JGG+47)   = TC1                                             INGV01    166
CD     DDAT(JGG+48)   = TC2                                             INGV01    167
CD     DDAT(JGG+49)   = TC3                                             INGV01    168
CD     DDAT(JGG+50)   = TC4                                             INGV01    169
CD     DDAT(JGG+51)   = TC5                                             INGV01    170
CD     DDAT(JGG+52)   = LC1                                             INGV01    171
CD     DDAT(JGG+53)   = LC2                                             INGV01    172
CD     DDAT(JGG+54)   = (reserved for future use)                       INGV01    173
CD     DDAT(JGG+55)   = PC1                                             INGV01    174
CD     DDAT(JGG+56)   = AC1                                             INGV01    175
CD     DDAT(JGG+57)   = PC2                                             INGV01    176
CD     DDAT(JGG+58)   = AC2                                             INGV01    177
CD     DDAT(JGG+59)   = XC1                                             INGV01    178
CD     DDAT(JGG+60)   = YC1                                             INGV01    179
CD     DDAT(JGG+61)   = XC2                                             INGV01    180
CD     DDAT(JGG+62)   = YC2                                             INGV01    181
CD     DDAT(JGG+63)   = CDB1                                            INGV01    182
CD     DDAT(JGG+64)   = CDB2                                            INGV01    183
CD     IDDAT(JGG+65)  = ILN                                             INGV01    184
CD     IDDAT(JGG+66)  = IFV                                             INGV01    185
CD                                                                      INGV01    186
CD     Governor states                                                  INGV01    187
CD                                                                      INGV01    188
CD     XSTATE(JPS+ 1) = THP block                   : compulsory        INGV01    189
CD     XSTATE(JPS+ 2) = TRH block                   : compulsory        INGV01    190
CD     XSTATE(JPS+ 3) = TIP block                   : compulsory        INGV01    191
CD     XSTATE(JPS+ 4) = TLP block                   : compulsory        INGV01    192
CD     XSTATE(JPS+ 5) = TC3 block                   : compulsory        INGV01    193
CD     XSTATE(JPS+ 6) = TC1 block                   : compulsory        INGV01    194
CD     XSTATE(JPS+ 7) = TC5 block                   : compulsory        INGV01    195
CD     XSTATE(JPS+ 8) = TI3 block                   : compulsory        INGV01    196
CD     XSTATE(JPS+ 9) = TI1 block                   : compulsory        INGV01    197
CD     XSTATE(JPS+10) = TI5 block                   : compulsory        INGV01    198
CD     XSTATE(JPS+11) = TR block                    : compulsory        INGV01    199
CD                                                                      INGV01    200
CD     Governor Y-variables                                             INGV01    201
CD                                                                      INGV01    202
CD     XLDREF(JYP+ 1) = load reference signal                           INGV01    203
CD     CVP(JYP+ 2)    = control valve position                          INGV01    204
CD     BLRPR(JYP+ 3)  = boiler/reactor pressure                         INGV01    205
CD     PVP(JYP+ 4)    = pilot valve position                            INGV01    206
CD     AIV(JYP+ 5)    = updated value of multiplier A                   INGV01    207
CD     FAIV(JYP+ 6)   = intercept valve flow area                       INGV01    208
CD     FACV(JYP+ 7)   = control valve flow area                         INGV01    209
CD     INTL(JYP+ 8)   = integer for acceleration sensitive control      INGV01    210
CD                      = 0    the control is not triggered             INGV01    211
CD                      = 1    the control is triggered for the time    INGV01    212
CD                             less than T1 seconds; no signal has been INGV01    213
CD                             applied yet                              INGV01    214
CD                      = 2    the control is triggered and the signal  INGV01    215
CD                             is applied                               INGV01    216
CD     TSNTL(JYP+ 9)  = acceleration sensitive control trigger time     INGV01    217
CD     AKIV(JYP+10)   = steady-state value of multiplier A              INGV01    218
CD     PDEM(JYP+11)   = power demand from AGC control                   INGV01    219
CD     PSET(JYP+12)   = set point for boiler pressure control           INGV01    220
CD                                                                      INGV01    221
      INCLUDE 'PARX.INS'                                                INGV01    222
      INCLUDE 'CNB1.INS'                                                INGV01    223
      INCLUDE 'CNB3.INS'                                                INGV01    224
      INCLUDE 'CNB4.INS'                                                INGV01    225
      INCLUDE 'CNB10.INS'                                               INGV01    226
      INCLUDE 'CNB19.INS'                                               INGV01    227
      INCLUDE 'CNG3.INS'                                                INGV01    228
      INCLUDE 'CNSTN.INS'                                               INGV01    229
      INCLUDE 'CNXSTA.INS'                                              INGV01    230
      INCLUDE 'CNMDAT.INS'                                              INGV01    231
      INCLUDE 'CNMSTA.INS'                                              INGV01    232
      INCLUDE 'CNEXC.INS'                                               INGV01    233
      INCLUDE 'CNPRGV.INS'                                              INGV01    234
      INCLUDE 'CNMYVA.INS'                                              INGV01    235
      INCLUDE 'CNYVAR.INS'                                              INGV01    236
      INCLUDE 'CNUNIT.INS'                                              INGV01    237
      INCLUDE 'CNMSG.INS'                                               INGV01    238
C                                                                       INGV01    239
C     INITIALIZING PRIME MOVER-GOVERNOR EQUATIONS, TYPE 1 & TYPE 2      INGV01    240
C                                                                       INGV01    241
C                                                                       INGV01    242
C                                                                       INGV01    243
      IGVNB=0                                                           INGV01    244
*IF LTSP                                                                INGV01    245
*ENDIF                                                                  INGV01    250
C                                                                       INGV01    251
C  INPUT TIME CONSTANTS CHECK AND RESET                                 INGV01    252
C                                                                       INGV01    253
      IF(DDAT(JGG+18).LT.TMIN)THEN                                      INGV01    254
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    255
     *                     ,NDGC(N)                                     INGV01    256
         IF(IGVN.EQ.2)THEN                                              INGV01    257
            WRITE(MSG(2),9021) 'TRH',DDAT(JGG+18)                       INGV01    258
            IF(MTFLAG.EQ.0) THEN                                        INGV01    259
               WRITE(MSG(3),9031) TMIN                                  INGV01    260
            ELSE                                                        INGV01    261
               WRITE(MSG(3),9031) TMIN,'TRH',TMIN                       INGV01    262
               DDAT(JGG+18)=TMIN                                        INGV01    263
            ENDIF                                                       INGV01    264
            CALL PRTMSG(3)                                              INGV01    265
         ELSE                                                           INGV01    266
            WRITE(MSG(2),9020) 'TRH',DDAT(JGG+18),TMIN                  INGV01    267
            IF(MTFLAG.EQ.0) THEN                                        INGV01    268
               CALL PRTMSG(2)                                           INGV01    269
            ELSE                                                        INGV01    270
               WRITE(MSG(3),9030) 'TRH',TMIN                            INGV01    271
               CALL PRTMSG(3)                                           INGV01    272
               DDAT(JGG+18)=TMIN                                        INGV01    273
            ENDIF                                                       INGV01    274
         ENDIF                                                          INGV01    275
      ENDIF                                                             INGV01    276
C                                                                       INGV01    277
      IF(DDAT(JGG+49).LT.TMIN)THEN                                      INGV01    278
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    279
     *                     ,NDGC(N)                                     INGV01    280
         IF(IGVN.EQ.2)THEN                                              INGV01    281
            WRITE(MSG(2),9021) 'TC3',DDAT(JGG+49)                       INGV01    282
            IF(MTFLAG.EQ.0) THEN                                        INGV01    283
               WRITE(MSG(3),9031) TMIN                                  INGV01    284
            ELSE                                                        INGV01    285
               WRITE(MSG(3),9031) TMIN,'TC3',1.0                        INGV01    286
               DDAT(JGG+49)=1.0                                         INGV01    287
            ENDIF                                                       INGV01    288
            CALL PRTMSG(3)                                              INGV01    289
         ELSE                                                           INGV01    290
            WRITE(MSG(2),9020) 'TC3',DDAT(JGG+49),TMIN                  INGV01    291
            IF(MTFLAG.EQ.0) THEN                                        INGV01    292
               CALL PRTMSG(2)                                           INGV01    293
            ELSE                                                        INGV01    294
               WRITE(MSG(3),9030) 'TC3',1.0                             INGV01    295
               CALL PRTMSG(3)                                           INGV01    296
               DDAT(JGG+49)=1.0                                         INGV01    297
            ENDIF                                                       INGV01    298
         ENDIF                                                          INGV01    299
      ENDIF                                                             INGV01    300
C                                                                       INGV01    301
      IF(DDAT(JGG+31).LT.TMIN)THEN                                      INGV01    302
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    303
     *                     ,NDGC(N)                                     INGV01    304
         IF(IGVN.EQ.2)THEN                                              INGV01    305
            WRITE(MSG(2),9021) 'TI3',DDAT(JGG+31)                       INGV01    306
            IF(MTFLAG.EQ.0) THEN                                        INGV01    307
               WRITE(MSG(3),9031) TMIN                                  INGV01    308
            ELSE                                                        INGV01    309
               WRITE(MSG(3),9031) TMIN,'TI3',1.0                        INGV01    310
               DDAT(JGG+31)=1.0                                         INGV01    311
            ENDIF                                                       INGV01    312
            CALL PRTMSG(3)                                              INGV01    313
         ELSE                                                           INGV01    314
            WRITE(MSG(2),9020) 'TI3',DDAT(JGG+31),TMIN                  INGV01    315
            IF(MTFLAG.EQ.0) THEN                                        INGV01    316
               CALL PRTMSG(2)                                           INGV01    317
            ELSE                                                        INGV01    318
               WRITE(MSG(3),9030) 'TI3',1.0                             INGV01    319
               CALL PRTMSG(3)                                           INGV01    320
               DDAT(JGG+31)=1.0                                         INGV01    321
            ENDIF                                                       INGV01    322
         ENDIF                                                          INGV01    323
      ENDIF                                                             INGV01    324
C                                                                       INGV01    325
      IF(DDAT(JGG+17).LT.TMIN.AND.IDDAT(JGG+17).NE.0)THEN               INGV01    326
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    327
     *                     ,NDGC(N)                                     INGV01    328
         IF(IGVN.EQ.2)THEN                                              INGV01    329
            WRITE(MSG(2),9021) 'THP',DDAT(JGG+17)                       INGV01    330
            IF(MTFLAG.EQ.0) THEN                                        INGV01    331
               WRITE(MSG(3),9031) TMIN                                  INGV01    332
            ELSE                                                        INGV01    333
               WRITE(MSG(3),9031) TMIN,'THP',TMIN                       INGV01    334
               DDAT(JGG+17)=TMIN                                        INGV01    335
            ENDIF                                                       INGV01    336
            CALL PRTMSG(3)                                              INGV01    337
         ELSE                                                           INGV01    338
            WRITE(MSG(2),9020) 'THP',DDAT(JGG+17),TMIN                  INGV01    339
            IF(MTFLAG.EQ.0) THEN                                        INGV01    340
               CALL PRTMSG(2)                                           INGV01    341
            ELSE                                                        INGV01    342
               WRITE(MSG(3),9030) 'THP',TMIN                            INGV01    343
               CALL PRTMSG(3)                                           INGV01    344
               DDAT(JGG+17)=TMIN                                        INGV01    345
            ENDIF                                                       INGV01    346
         ENDIF                                                          INGV01    347
      ENDIF                                                             INGV01    348
C                                                                       INGV01    349
      IF(DDAT(JGG+19).LT.TMIN.AND.IDDAT(JGG+19).NE.0)THEN               INGV01    350
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    351
     *                     ,NDGC(N)                                     INGV01    352
         IF(IGVN.EQ.2)THEN                                              INGV01    353
            WRITE(MSG(2),9021) 'TIP',DDAT(JGG+19)                       INGV01    354
            IF(MTFLAG.EQ.0) THEN                                        INGV01    355
               WRITE(MSG(3),9031) TMIN                                  INGV01    356
            ELSE                                                        INGV01    357
               WRITE(MSG(3),9031) TMIN,'TIP',0.0                        INGV01    358
               DDAT(JGG+19)=0.0                                         INGV01    359
            ENDIF                                                       INGV01    360
            CALL PRTMSG(3)                                              INGV01    361
         ELSE                                                           INGV01    362
            WRITE(MSG(2),9020) 'TIP',DDAT(JGG+19),TMIN                  INGV01    363
            IF(MTFLAG.EQ.0) THEN                                        INGV01    364
               CALL PRTMSG(2)                                           INGV01    365
            ELSE                                                        INGV01    366
               WRITE(MSG(3),9030) 'TIP',0.0                             INGV01    367
               CALL PRTMSG(3)                                           INGV01    368
               DDAT(JGG+19)=0.0                                         INGV01    369
            ENDIF                                                       INGV01    370
         ENDIF                                                          INGV01    371
      ENDIF                                                             INGV01    372
C                                                                       INGV01    373
      IF(DDAT(JGG+20).LT.TMIN.AND.IDDAT(JGG+20).NE.0)THEN               INGV01    374
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    375
     *                     ,NDGC(N)                                     INGV01    376
         IF(IGVN.EQ.2)THEN                                              INGV01    377
            WRITE(MSG(2),9021) 'TLP',DDAT(JGG+20)                       INGV01    378
            IF(MTFLAG.EQ.0) THEN                                        INGV01    379
               WRITE(MSG(3),9031) TMIN                                  INGV01    380
            ELSE                                                        INGV01    381
               WRITE(MSG(3),9031) TMIN,'TLP',TMIN                       INGV01    382
               DDAT(JGG+20)=TMIN                                        INGV01    383
            ENDIF                                                       INGV01    384
            CALL PRTMSG(3)                                              INGV01    385
         ELSE                                                           INGV01    386
            WRITE(MSG(2),9020) 'TLP',DDAT(JGG+20),TMIN                  INGV01    387
            IF(MTFLAG.EQ.0) THEN                                        INGV01    388
               CALL PRTMSG(2)                                           INGV01    389
            ELSE                                                        INGV01    390
               WRITE(MSG(3),9030) 'TLP',TMIN                            INGV01    391
               CALL PRTMSG(3)                                           INGV01    392
               DDAT(JGG+20)=TMIN                                        INGV01    393
            ENDIF                                                       INGV01    394
         ENDIF                                                          INGV01    395
      ENDIF                                                             INGV01    396
C                                                                       INGV01    397
      IF(DDAT(JGG+47).LT.TMIN.AND.IDDAT(JGG+47).NE.0)THEN               INGV01    398
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    399
     *                     ,NDGC(N)                                     INGV01    400
         IF(IGVN.EQ.2)THEN                                              INGV01    401
            WRITE(MSG(2),9021) 'TC1',DDAT(JGG+47)                       INGV01    402
            IF(MTFLAG.EQ.0) THEN                                        INGV01    403
               WRITE(MSG(3),9031) TMIN                                  INGV01    404
            ELSE                                                        INGV01    405
               WRITE(MSG(3),9031) TMIN,'TC1',0.0                        INGV01    406
               DDAT(JGG+47)=0.0                                         INGV01    407
            ENDIF                                                       INGV01    408
            CALL PRTMSG(3)                                              INGV01    409
         ELSE                                                           INGV01    410
            WRITE(MSG(2),9020) 'TC1',DDAT(JGG+47),TMIN                  INGV01    411
            IF(MTFLAG.EQ.0) THEN                                        INGV01    412
               CALL PRTMSG(2)                                           INGV01    413
            ELSE                                                        INGV01    414
               WRITE(MSG(3),9030) 'TC1',0.0                             INGV01    415
               CALL PRTMSG(3)                                           INGV01    416
               DDAT(JGG+47)=0.0                                         INGV01    417
            ENDIF                                                       INGV01    418
         ENDIF                                                          INGV01    419
      ENDIF                                                             INGV01    420
C                                                                       INGV01    421
      IF(DDAT(JGG+51).LT.TMIN.AND.IDDAT(JGG+51).NE.0)THEN               INGV01    422
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    423
     *                     ,NDGC(N)                                     INGV01    424
         IF(IGVN.EQ.2)THEN                                              INGV01    425
            WRITE(MSG(2),9021) 'TC5',DDAT(JGG+51)                       INGV01    426
            IF(MTFLAG.EQ.0) THEN                                        INGV01    427
               WRITE(MSG(3),9031) TMIN                                  INGV01    428
            ELSE                                                        INGV01    429
               WRITE(MSG(3),9031) TMIN,'TC5',0.0                        INGV01    430
               DDAT(JGG+51)=0.0                                         INGV01    431
            ENDIF                                                       INGV01    432
            CALL PRTMSG(3)                                              INGV01    433
         ELSE                                                           INGV01    434
            WRITE(MSG(2),9020) 'TC5',DDAT(JGG+51),TMIN                  INGV01    435
            IF(MTFLAG.EQ.0) THEN                                        INGV01    436
               CALL PRTMSG(2)                                           INGV01    437
            ELSE                                                        INGV01    438
               WRITE(MSG(3),9030) 'TC5',0.0                             INGV01    439
               CALL PRTMSG(3)                                           INGV01    440
               DDAT(JGG+51)=0.0                                         INGV01    441
            ENDIF                                                       INGV01    442
         ENDIF                                                          INGV01    443
      ENDIF                                                             INGV01    444
C                                                                       INGV01    445
      IF(DDAT(JGG+29).LT.TMIN.AND.IDDAT(JGG+29).NE.0)THEN               INGV01    446
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    447
     *                     ,NDGC(N)                                     INGV01    448
         IF(IGVN.EQ.2)THEN                                              INGV01    449
            WRITE(MSG(2),9021) 'TI1',DDAT(JGG+29)                       INGV01    450
            IF(MTFLAG.EQ.0) THEN                                        INGV01    451
               WRITE(MSG(3),9031) TMIN                                  INGV01    452
            ELSE                                                        INGV01    453
               WRITE(MSG(3),9031) TMIN,'TI1',0.0                        INGV01    454
               DDAT(JGG+29)=0.0                                         INGV01    455
            ENDIF                                                       INGV01    456
            CALL PRTMSG(3)                                              INGV01    457
         ELSE                                                           INGV01    458
            WRITE(MSG(2),9020) 'TI1',DDAT(JGG+29),TMIN                  INGV01    459
            IF(MTFLAG.EQ.0) THEN                                        INGV01    460
               CALL PRTMSG(2)                                           INGV01    461
            ELSE                                                        INGV01    462
               WRITE(MSG(3),9030) 'TI1',0.0                             INGV01    463
               CALL PRTMSG(3)                                           INGV01    464
               DDAT(JGG+29)=0.0                                         INGV01    465
            ENDIF                                                       INGV01    466
         ENDIF                                                          INGV01    467
      ENDIF                                                             INGV01    468
C                                                                       INGV01    469
      IF(DDAT(JGG+33).LT.TMIN.AND.IDDAT(JGG+33).NE.0)THEN               INGV01    470
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    471
     *                     ,NDGC(N)                                     INGV01    472
         IF(IGVN.EQ.2)THEN                                              INGV01    473
            WRITE(MSG(2),9021) 'TI5',DDAT(JGG+33)                       INGV01    474
            IF(MTFLAG.EQ.0) THEN                                        INGV01    475
               WRITE(MSG(3),9031) TMIN                                  INGV01    476
            ELSE                                                        INGV01    477
               WRITE(MSG(3),9031) TMIN,'TI5',0.0                        INGV01    478
               DDAT(JGG+33)=0.0                                         INGV01    479
            ENDIF                                                       INGV01    480
            CALL PRTMSG(3)                                              INGV01    481
         ELSE                                                           INGV01    482
            WRITE(MSG(2),9020) 'TI5',DDAT(JGG+33),TMIN                  INGV01    483
            IF(MTFLAG.EQ.0) THEN                                        INGV01    484
               CALL PRTMSG(2)                                           INGV01    485
            ELSE                                                        INGV01    486
               WRITE(MSG(3),9030) 'TI5',0.0                             INGV01    487
               CALL PRTMSG(3)                                           INGV01    488
               DDAT(JGG+33)=0.0                                         INGV01    489
            ENDIF                                                       INGV01    490
         ENDIF                                                          INGV01    491
      ENDIF                                                             INGV01    492
C                                                                       INGV01    493
      IF(DDAT(JGG+9).LT.TMIN.AND.IDDAT(JGG+9).NE.0)THEN                 INGV01    494
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    495
     *                     ,NDGC(N)                                     INGV01    496
         IF(IGVN.EQ.2)THEN                                              INGV01    497
            WRITE(MSG(2),9021) 'TSR',DDAT(JGG+9)                        INGV01    498
            IF(MTFLAG.EQ.0) THEN                                        INGV01    499
               WRITE(MSG(3),9031) TMIN                                  INGV01    500
            ELSE                                                        INGV01    501
               WRITE(MSG(3),9031) TMIN,'TSR',0.0                        INGV01    502
               DDAT(JGG+9)=0.0                                          INGV01    503
            ENDIF                                                       INGV01    504
            CALL PRTMSG(3)                                              INGV01    505
         ELSE                                                           INGV01    506
            WRITE(MSG(2),9020) 'TSR',DDAT(JGG+9),TMIN                   INGV01    507
            IF(MTFLAG.EQ.0) THEN                                        INGV01    508
               CALL PRTMSG(2)                                           INGV01    509
            ELSE                                                        INGV01    510
               WRITE(MSG(3),9030) 'TSR',0.0                             INGV01    511
               CALL PRTMSG(3)                                           INGV01    512
               DDAT(JGG+9)=0.0                                          INGV01    513
            ENDIF                                                       INGV01    514
         ENDIF                                                          INGV01    515
      ENDIF                                                             INGV01    516
C                                                                       INGV01    517
      IF(DDAT(JGG+48).LT.TMIN)THEN                                      INGV01    518
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    519
     *                     ,NDGC(N)                                     INGV01    520
         IF(IGVN.EQ.2)THEN                                              INGV01    521
            WRITE(MSG(2),9021) 'TC2',DDAT(JGG+48)                       INGV01    522
            IF(MTFLAG.EQ.0) THEN                                        INGV01    523
               WRITE(MSG(3),9031) TMIN                                  INGV01    524
            ELSE                                                        INGV01    525
               WRITE(MSG(3),9031) TMIN,'TC2',1.0                        INGV01    526
               DDAT(JGG+48)=1.0                                         INGV01    527
            ENDIF                                                       INGV01    528
            CALL PRTMSG(3)                                              INGV01    529
         ELSE                                                           INGV01    530
            WRITE(MSG(2),9020) 'TC2',DDAT(JGG+48),TMIN                  INGV01    531
            IF(MTFLAG.EQ.0) THEN                                        INGV01    532
               CALL PRTMSG(2)                                           INGV01    533
            ELSE                                                        INGV01    534
               WRITE(MSG(3),9030) 'TC2',1.0                             INGV01    535
               CALL PRTMSG(3)                                           INGV01    536
               DDAT(JGG+48)=1.0                                         INGV01    537
            ENDIF                                                       INGV01    538
         ENDIF                                                          INGV01    539
      ENDIF                                                             INGV01    540
C                                                                       INGV01    541
      IF(DDAT(JGG+30).LT.TMIN)THEN                                      INGV01    542
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INGV01    543
     *                     ,NDGC(N)                                     INGV01    544
         IF(IGVN.EQ.2)THEN                                              INGV01    545
            WRITE(MSG(2),9021) 'TI2',DDAT(JGG+30)                       INGV01    546
            IF(MTFLAG.EQ.0) THEN                                        INGV01    547
               WRITE(MSG(3),9031) TMIN                                  INGV01    548
            ELSE                                                        INGV01    549
               WRITE(MSG(3),9031) TMIN,'TI2',1.0                        INGV01    550
               DDAT(JGG+30)=1.0                                         INGV01    551
            ENDIF                                                       INGV01    552
            CALL PRTMSG(3)                                              INGV01    553
         ELSE                                                           INGV01    554
            WRITE(MSG(2),9020) 'TI2',DDAT(JGG+30),TMIN                  INGV01    555
            IF(MTFLAG.EQ.0) THEN                                        INGV01    556
               CALL PRTMSG(2)                                           INGV01    557
            ELSE                                                        INGV01    558
               WRITE(MSG(3),9030) 'TI2',1.0                             INGV01    559
               CALL PRTMSG(3)                                           INGV01    560
               DDAT(JGG+30)=1.0                                         INGV01    561
            ENDIF                                                       INGV01    562
         ENDIF                                                          INGV01    563
      ENDIF                                                             INGV01    564
C                                                                       INGV01    565
C     THERMAL UNITS -DETAILED MODELS                                    INGV01    566
C                                                                       INGV01    567
C-- RETRIEVING "ILNN" & "IFVN", SET STATE COUNTER                       INGV01    568
      ZERO=1.0E-6                                                       INGV01    569
      BIG=99.9                                                          INGV01    570
      ILNN=IDDAT(JGG+65)                                                INGV01    571
      IFVN=IDDAT(JGG+66)                                                INGV01    572
      KSTATE=11                                                         INGV01    573
C     PINTLX=MAX. POWER (COMMON MVA BASE) WITH FULL OPEN C.V. POSITION  INGV01    574
C PINTL(JYP+8)=GEN/MAX. POWER (COMMON MVA BASE) WITH FULL OPEN C.V. POSIINGV01    575
      BASPRN=DDAT(JG+3)/BASPC                                           INGV01    576
      DDAT(JGG+24)=DDAT(JGG+24)*BASPRN                                  INGV01    577
      PINTLX=DDAT(JGG+24)                                               INGV01    578
C      DDAT(JGG+24)=PDG(JYG+2)/PINTLX                                   INGV01    579
      XINIT=PDG(JYG+2)/PINTLX                                           INGV01    580
C  DEFAULT VALUES                                                       INGV01    581
      IF (IGVN.EQ.3) DDAT(JGG+8)=DDAT(JGG+2)                            INGV01    582
      IF (DDAT(JGG+48).LT.1.E-6) DDAT(JGG+48)=1.0                       INGV01    583
      IF (DDAT(JGG+30).LT.1.E-6) DDAT(JGG+30)=1.0                       INGV01    584
      IF (DDAT(JGG+49).LT.1.E-6) DDAT(JGG+49)=1.0                       INGV01    585
      IF (DDAT(JGG+31).LT.1.E-6) DDAT(JGG+31)=1.0                       INGV01    586
      IF (DDAT(JGG+8).LT.1.E-6) DDAT(JGG+8)=1.0                         INGV01    587
      IVFDBK=1                                                          INGV01    588
      IF(ILNN.NE.1)GOTO 41                                              INGV01    589
C      IVFDBK=1                                                         INGV01    590
      IF(DDAT(JGG+41).LT.ZERO.AND.DDAT(JGG+42).LT.ZERO.AND.             INGV01    591
     1 DDAT(JGG+43).LT.ZERO.AND.DDAT(JGG+44).LT.ZERO)IVFDBK=0           INGV01    592
 41   CONTINUE                                                          INGV01    593
      IF ((ABS(DDAT(JGG+10)).LT.1.E-6).AND.(ABS(DDAT(JGG+11))           INGV01    594
     +  .LT.1.E-6)) GO TO 40                                            INGV01    595
      GO TO 50                                                          INGV01    596
40    DDAT(JGG+10)=BIG                                                  INGV01    597
      DDAT(JGG+11)=-BIG                                                 INGV01    598
50    CONTINUE                                                          INGV01    599
C   ACCELERATION SENSITIVE DEVICE VARIABLES                             INGV01    600
C                                                                       INGV01    601
      INTL(JYP+8)=0                                                     INGV01    602
      TSNTL(JYP+9)=0.0                                                  INGV01    603
C     TURBINE                                                           INGV01    604
      XSTATE(JSTATE+1)=XINIT                                            INGV01    605
      XSTATE(JSTATE+3)=XINIT                                            INGV01    606
      XSTATE(JSTATE+4)=XINIT                                            INGV01    607
C    A - FACTOR OF IV FLOW                                              INGV01    608
      XEK1=2.0/DDAT(JGG+26)                                             INGV01    609
      XEK2=(DDAT(JGG+26)+1.0)/DDAT(JGG+26)                              INGV01    610
      XPR=1.0-(DDAT(JGG+27)/100.)                                       INGV01    611
      XEKK=(XPR**XEK1)-(XPR**XEK2)                                      INGV01    612
      XEKK=SQRT(XEKK)                                                   INGV01    613
      AKIV(JYP+10)=1.0/XEKK                                             INGV01    614
      AIV(JYP+5)=1.0                                                    INGV01    615
      IF(IVFDBK.EQ.0)AKIV(JYP+10)=1.0                                   INGV01    616
C     CV FLOW AREA                                                      INGV01    617
C      FACV(JYP+7)=DDAT(JGG+24)/DDAT(JGG+25)                            INGV01    618
      FACV(JYP+7)=XINIT/DDAT(JGG+25)                                    INGV01    619
C     BOILER/REACTOR PRESSURE                                           INGV01    620
      BLRPR(JYP+3)=XINIT/FACV(JYP+7)                                    INGV01    621
      XMASS=FACV(JYP+7)/BLRPR(JYP+3)                                    INGV01    622
C     CV LIFT                                                           INGV01    623
      XPN1=DDAT(JGG+56)                                                 INGV01    624
      YFA1=DDAT(JGG+55)                                                 INGV01    625
      XPN2=DDAT(JGG+58)                                                 INGV01    626
      YFA2=DDAT(JGG+57)                                                 INGV01    627
      XPIN=FACV(JYP+7)                                                  INGV01    628
      CALL NLCHAR                                                       INGV01    629
      XSTATE(JSTATE+5)=YOUT                                             INGV01    630
      CVP(JYP+2)=XSTATE(JSTATE+5)                                       INGV01    631
C   INITIALIZING NON-ZERO DEAD BAND VARIABLES                           INGV01    632
      DDAT(JGG+71)=XSTATE(JSTATE+5)                                     INGV01    633
      DDAT(JGG+72)=DDAT(JGG+71)                                         INGV01    634
      XSTATE(JSTATE+6)=0.0                                              INGV01    635
      XSTATE(JSTATE+7)=XSTATE(JSTATE+5)                                 INGV01    636
      IF (IGVN.GT.2) GO TO 80                                           INGV01    637
      IF (ILNN.EQ.0) GO TO 80                                           INGV01    638
      IF (ILNN.EQ.1) GO TO 60                                           INGV01    639
C   FEEDBACK LINEARIZATION                                              INGV01    640
      XPN1=DDAT(JGG+60)                                                 INGV01    641
      YFA1=DDAT(JGG+59)                                                 INGV01    642
      XPN2=DDAT(JGG+62)                                                 INGV01    643
      YFA2=DDAT(JGG+61)                                                 INGV01    644
      XPIN=XSTATE(JSTATE+5)                                             INGV01    645
      GO TO 70                                                          INGV01    646
C   FEEDBACK LINEARIZATION                                              INGV01    647
60    XPN1=DDAT(JGG+59)                                                 INGV01    648
      YFA1=DDAT(JGG+60)                                                 INGV01    649
      XPN2=DDAT(JGG+61)                                                 INGV01    650
      YFA2=DDAT(JGG+62)                                                 INGV01    651
      XPIN=XSTATE(JSTATE+5)                                             INGV01    652
70    CONTINUE                                                          INGV01    653
      CALL NLCHAR                                                       INGV01    654
      XSTATE(JSTATE+7)=YOUT                                             INGV01    655
80    XLDREF(JYP+1)=XSTATE(JSTATE+7)                                    INGV01    656
      XSTATE(JSTATE+10)=XSTATE(JSTATE+7)                                INGV01    657
      PVP(JYP+4)=XSTATE(JSTATE+10)                                      INGV01    658
      XSTATE(JSTATE+11)=XSTATE(JSTATE+7)                                INGV01    659
      IF (IGVN.EQ.3) XSTATE(JSTATE+11)=0.0                              INGV01    660
C      IV LIFT AND FLOW AREA                                            INGV01    661
      XSUM=(XSTATE(JSTATE+10)+DDAT(JGG+36))*DDAT(JGG+8)                 INGV01    662
      IF (ILNN.LT.2) GO TO 100                                          INGV01    663
C     FEED FORWARD LINEARIZATION                                        INGV01    664
      IF (ILNN.NE.2) GO TO 90                                           INGV01    665
      IF (XSUM.GT.1.0) XSUM=1.0                                         INGV01    666
      IF (XSUM.LT.0.0) XSUM=0.0                                         INGV01    667
90    XPN1=DDAT(JGG+42)                                                 INGV01    668
      YFA1=DDAT(JGG+41)                                                 INGV01    669
      XPN2=DDAT(JGG+44)                                                 INGV01    670
      YFA2=DDAT(JGG+43)                                                 INGV01    671
      XPIN=XSUM                                                         INGV01    672
      CALL NLCHAR                                                       INGV01    673
      XSUM=YOUT                                                         INGV01    674
C                                                                       INGV01    675
100   IF (XSUM.LT.1.0.AND.IVFDBK.NE.0) GO TO 110                        INGV01    676
      FAIV(JYP+6)=1.0                                                   INGV01    677
      XSTATE(JSTATE+8)=1.0                                              INGV01    678
      XSTATE(JSTATE+9)=XSUM/DDAT(JGG+30)                                INGV01    679
      IF(IVFDBK.NE.0)XSTATE(JSTATE+9)=XSTATE(JSTATE+9)-1.0/DDAT(JGG+30) INGV01    680
      IF(XSTATE(JSTATE+9).GT.DDAT(JGG+34))THEN                          INGV01    681
        XSTATE(JSTATE+9)=DDAT(JGG+34)                                   INGV01    682
        IF(DDAT(JGG+36).EQ.0.0)THEN                                     INGV01    683
          WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN),     INGV01    684
     &                       NDGC(N)                                    INGV01    685
          IF(IGVN.EQ.2)THEN                                             INGV01    686
             WRITE(MSG(2),9041) XSUM                                    INGV01    687
          ELSE                                                          INGV01    688
             WRITE(MSG(2),9040) XSUM                                    INGV01    689
          ENDIF                                                         INGV01    690
          WRITE(MSG(3),9050) 1.0                                        INGV01    691
          CALL PRTMSG(3)                                                INGV01    692
        ENDIF                                                           INGV01    693
      ENDIF                                                             INGV01    694
      GO TO 130                                                         INGV01    695
                                                                        INGV01    696
110   XSTATE(JSTATE+9)=0.0                                              INGV01    697
      XSTATE(JSTATE+8)=XSUM                                             INGV01    698
      IF (ILNN.NE.1) GO TO 120                                          INGV01    699
C     FEEDBACK LINEARIZATION                                            INGV01    700
      XPN1=DDAT(JGG+42)                                                 INGV01    701
      YFA1=DDAT(JGG+41)                                                 INGV01    702
      XPN2=DDAT(JGG+44)                                                 INGV01    703
      YFA2=DDAT(JGG+43)                                                 INGV01    704
      XPIN=XSUM                                                         INGV01    705
      CALL NLCHAR                                                       INGV01    706
      XSTATE(JSTATE+8)=YOUT                                             INGV01    707
120   XPN1=DDAT(JGG+37)                                                 INGV01    708
      YFA1=DDAT(JGG+38)                                                 INGV01    709
      XPN2=DDAT(JGG+39)                                                 INGV01    710
      YFA2=DDAT(JGG+40)                                                 INGV01    711
      XPIN=XSTATE(JSTATE+8)                                             INGV01    712
      CALL NLCHAR                                                       INGV01    713
      FAIV(JYP+6)=YOUT                                                  INGV01    714
C                                                                       INGV01    715
130   CONTINUE                                                          INGV01    716
C INITIALIZING NON-ZERO DEAD BAND VARIABLES                             INGV01    717
      DDAT(JGG+77)=XSTATE(JSTATE+8)                                     INGV01    718
      DDAT(JGG+78)=DDAT(JGG+77)                                         INGV01    719
      DDAT(JGG+74)=XSTATE(JSTATE+9)*DDAT(JGG+30)                        INGV01    720
      DDAT(JGG+75)=DDAT(JGG+74)                                         INGV01    721
      XSTATE(JSTATE+2)=XINIT/FAIV(JYP+6)                                INGV01    722
      FLP=1.-DDAT(JGG+22)-DDAT(JGG+23)                                  INGV01    723
      ILNP=0                                                            INGV01    724
 200  IF (ILNP.NE.0) GO TO 210                                          INGV01    725
      DB1=DDAT(JGG+63)                                                  INGV01    726
      DB2=DDAT(JGG+64)                                                  INGV01    727
      DDAT(JGG+63)=0.5*DDAT(JGG+63)                                     INGV01    728
      DDAT(JGG+64)=0.5*DDAT(JGG+64)                                     INGV01    729
      GO TO 220                                                         INGV01    730
210   DB1=DDAT(JGG+45)                                                  INGV01    731
      DB2=DDAT(JGG+46)                                                  INGV01    732
      DDAT(JGG+45)=0.5*DDAT(JGG+45)                                     INGV01    733
      DDAT(JGG+46)=0.5*DDAT(JGG+46)                                     INGV01    734
220   CONTINUE                                                          INGV01    735
      IF (ILNP.NE.0) GO TO 240                                          INGV01    736
      ILNP=ILNP+1                                                       INGV01    737
      GO TO 200                                                         INGV01    738
240   CONTINUE                                                          INGV01    739
C                                                                       INGV01    740
      JY=JY+10                                                          INGV01    741
C                                                                       INGV01    742
C  SIMPIFIED BOILER                                                     INGV01    743
C                                                                       INGV01    744
      IF(IGVNB.NE.0)THEN                                                INGV01    745
        KSTATE=KSTATE+8                                                 INGV01    746
        DO 245 I=12,19                                                  INGV01    747
          XSTATE(JSTATE+I)=XINIT                                        INGV01    748
 245    CONTINUE                                                        INGV01    749
        XSTATE(JSTATE+19)=XSTATE(JSTATE+7)                              INGV01    750
        PDEM(JYP+11)=DDAT(JGG+91)*XSTATE(JSTATE+19)                     INGV01    751
     *              +DDAT(JGG+92)*XINIT                                 INGV01    752
        XSTATE(JSTATE+17)=XINIT-PDEM(JYP+11)*DDAT(JGG+95)               INGV01    753
        XSTATE(JSTATE+16)=XSTATE(JSTATE+17)                             INGV01    754
        XSTATE(JSTATE+15)=FACV(JYP+7)/XSTATE(JSTATE+2)                  INGV01    755
        PSET(JYP+12)=BLRPR(JYP+3)                                       INGV01    756
        XSTATE(JSTATE+14)=XSTATE(JSTATE+15)+(XMASS/DDAT(JGG+84))**2     INGV01    757
        JY=JY+2                                                         INGV01    758
      ENDIF                                                             INGV01    759
      MSTATE(6,N)=JSTATE+KSTATE                                         INGV01    760
C                                                                       INGV01    761
      IF (IGSTAN.EQ.0) GO TO 360                                        INGV01    762
      MYVAR(6,N)=JY                                                     INGV01    763
      JYPS=JY                                                           INGV01    764
      IF (IGSTAN.EQ.1) DDAT(JGS+1)=DDAT(JGS+1)/BASPRN                   INGV01    765
      IF (DDAT(JGS+5).GT.ZERO.AND.ABS(DDAT(JGS+6)).GT.ZERO)             INGV01    766
     +   GO TO 350                                                      INGV01    767
      DDAT(JGS+5)=BIG                                                   INGV01    768
      DDAT(JGS+6)=-BIG                                                  INGV01    769
350   CONTINUE                                                          INGV01    770
      PDGN=PDG(JYG+2)                                                   INGV01    771
C                                                                       INGV01    772
      KSTATE=KSTATE+1                                                   INGV01    773
      XSTATE(JSTATE+KSTATE)=(PDGN*DDAT(JGS+2)+CVP(JYP+2)*DDAT(JGS+3))*  INGV01    774
     +   DDAT(JGS+4)                                                    INGV01    775
      IGNXSN=IDDAT(JS+1)                                                INGV01    776
      XSTATE(IGNXSN)=(PDGN*DDAT(JS+2)+CVP(JYP+2)*DDAT(JS+3))*DDAT(JS+4) INGV01    777
      DDAT(JS+4)=1.0/DDAT(JS+4)                                         INGV01    778
      DDAT(JGS+4)=1.0/DDAT(JGS+4)                                       INGV01    779
      WXBASE=DDAT(JG+5)                                                 INGV01    780
      DDAT(JGS+1)=DDAT(JGS+1)/WXBASE                                    INGV01    781
C                                                                       INGV01    782
      GSS(JYPS+1)=0.0                                                   INGV01    783
      JY=JY+1                                                           INGV01    784
360   CONTINUE                                                          INGV01    785
      JSTATE=JSTATE+KSTATE                                              INGV01    786
C                                                                       INGV01    787
C  UPDATE THE INITIAL VALUE OF THE STATE IN STAB TYPE 7, IF HAPPENED.   INGV01    788
C                                                                       INGV01    789
      IF(ISTABN.EQ.7)THEN                                               INGV01    790
         JSTB7=MSTATE(3,N)+1                                            INGV01    791
         XSTATE(JSTB7)=XSTATE(JSTB7)+DDAT(JS+4)*CVP(JYP+2)              INGV01    792
      ENDIF                                                             INGV01    793
C                                                                       INGV01    794
      RETURN                                                            INGV01    795
C                                                                       INGV01    796
 9000 FORMAT(' *** WARNING GENERATOR AT BUS: ',I5,' STATION: ',3A4      INGV01    797
     *,' GID:',A4)                                                      INGV01    798
 9020 FORMAT(5X,'TYPE 1 GOVERNOR ',A,'=',F8.6                           INGV01    799
     *,' IS BELOW THE LIMIT VALUE OF ',F4.2)                            INGV01    800
 9030 FORMAT(5X,A,' HAS BEEN SET TO ',F4.2)                             INGV01    801
 9021 FORMAT(5X,'TYPE 2 (WSCC TYPE GC) GOVERNOR ',A,'=',F8.6            INGV01    802
     *,' IS BELOW THE LIMIT VALUE')                                     INGV01    803
 9031 FORMAT(5X,'OF',F5.2,'. ',:,A,' HAS BEEN SET TO ',F4.2)            INGV01    804
 9040 FORMAT(5X,'TYPE 1 GOVERNOR STATE NO. 8 =',F8.6,' IS EXCEEDS')     INGV01    805
 9041 FORMAT(5X,'TYPE 2 (WSCC TYPE GC) GOVERNOR STATE NO. 8 =',F8.6     INGV01    806
     *,' IS EXCEEDS')                                                   INGV01    807
 9050 FORMAT(5X,'THE SCOPE BETWEEN 0.0 AND 1.0, THE VALUE IS SET TO'    INGV01    808
     *,F9.6)                                                            INGV01    809
      END                                                               INGV01    810
